#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os, sys
import tempfile

def convertir(arch_ogg, arch_mp3):
    _, tmp = tempfile.mkstemp()
    cmd = '/usr/bin/oggdec "%s" -o "%s"' % (arch_ogg, tmp)
    os.system(cmd)

    cmd = '/usr/bin/lame "%s" "%s"' % (tmp, arch_mp3)
    os.system(cmd)
    os.remove(tmp)
    return


def main(archivos):
    for nomfull in archivos:
        print "\n\n------------------------------------\nProcesando %r\n" % nomfull
        newname = nomfull[:-4] + ".mp3"
        convertir(nomfull, newname)
    print "Listo."
    return


def getArchivos(argum):
    # verificamos que son todos validos
    todo_ok = True
    for arg in argum:
        if not os.access(arg, os.R_OK):
            print "No se puede leer %r" % arg
            todo_ok = False
    if not todo_ok:
        sys.exit()

    def is_vorbis(fname):
        return fname.split(".")[-1].lower() in ('ogg', 'oga', 'opus')

    # procesamos
    todos = []
    for arg in argum:
        if os.path.isdir(arg):
            archivos = os.listdir(arg)
            archivos = [os.path.join(arg, x) for x in archivos if is_vorbis(x)]
        elif os.path.isfile(arg) and is_vorbis(arg):
            archivos = [arg]
        else:
            print "ERROR: %r no es directorio ni archivo!" % arg
        todos.extend(archivos)
    return todos


if __name__ == "__main__":
    if len(sys.argv) < 2:
        print "usar ogg2mp3.py <archivos.ogg y/o directorios con archivos.ogg dentro>"
        sys.exit()

    archivos = getArchivos(sys.argv[1:])
    main(archivos)
